searchNodes=[{"ref":"AMQP.Basic.html","title":"AMQP.Basic","module":"AMQP.Basic","type":"module","doc":"Functions to publish, consume and acknowledge messages."},{"ref":"AMQP.Basic.html#ack/3","title":"AMQP.Basic.ack/3","module":"AMQP.Basic","type":"function","doc":"Acknowledges one or more messages. If multiple is set to true, all messages up to the one specified by delivery_tag are considered acknowledged by the server."},{"ref":"AMQP.Basic.html#cancel/3","title":"AMQP.Basic.cancel/3","module":"AMQP.Basic","type":"function","doc":"End a queue consumer. This method cancels a consumer. This does not affect already delivered messages, but it does mean the server will not send any more messages for that consumer. The client may receive an arbitrary number of messages in between sending the cancel method and receiving the reply."},{"ref":"AMQP.Basic.html#cancel_return/1","title":"AMQP.Basic.cancel_return/1","module":"AMQP.Basic","type":"function","doc":"Removes the return handler, if it exists. Does nothing if there is no such handler."},{"ref":"AMQP.Basic.html#consume/4","title":"AMQP.Basic.consume/4","module":"AMQP.Basic","type":"function","doc":"Registers a queue consumer process. The pid of the process can be set using the consumer_pid argument and defaults to the calling process. The consumer process will receive the following data structures: {:basic_deliver, payload, meta} - This is sent for each message consumed, where payload contains the message content and meta contains all the metadata set when sending with Basic.publish or additional info set by the broker; {:basic_consume_ok, %{consumer_tag: consumer_tag}} - Sent when the consumer process is registered with Basic.consume. The caller receives the same information as the return of Basic.consume; {:basic_cancel, %{consumer_tag: consumer_tag, no_wait: no_wait}} - Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion) {:basic_cancel_ok, %{consumer_tag: consumer_tag}} - Sent to the consumer process after a call to Basic.cancel"},{"ref":"AMQP.Basic.html#get/3","title":"AMQP.Basic.get/3","module":"AMQP.Basic","type":"function","doc":"Polls a queue for an existing message. Returns the tuple {:empty, meta} if the queue is empty or the tuple {:ok, payload, meta} if at least one message exists in the queue. The returned meta map includes the entry message_count with the current number of messages in the queue. Receiving messages by polling a queue is not as as efficient as subscribing a consumer to a queue, so consideration should be taken when receiving large volumes of messages. Setting the no_ack option to true will tell the broker that the receiver will not send an acknowledgement of the message. Once it believes it has delivered a message, then it is free to assume that the consuming application has taken responsibility for it. In general, a lot of applications will not want these semantics, rather, they will want to explicitly acknowledge the receipt of a message and have no_ack with the default value of false."},{"ref":"AMQP.Basic.html#nack/3","title":"AMQP.Basic.nack/3","module":"AMQP.Basic","type":"function","doc":"Negative acknowledge of one or more messages. If multiple is set to true, all messages up to the one specified by delivery_tag are considered as not acknowledged by the server. If requeue is set to true, the message will be returned to the queue and redelivered to the next available consumer. This is a RabbitMQ specific extension to AMQP 0.9.1. It is equivalent to reject, but allows rejecting multiple messages using the multiple option."},{"ref":"AMQP.Basic.html#publish/5","title":"AMQP.Basic.publish/5","module":"AMQP.Basic","type":"function","doc":"Publishes a message to an Exchange. This method publishes a message to a specific exchange. The message will be routed to queues as defined by the exchange configuration and distributed to any subscribers. The parameter exchange specifies the name of the exchange to publish to. If set to empty string, it publishes to the default exchange. The routing_key parameter specifies the routing key for the message. The payload parameter specifies the message content as a binary. In addition to the previous parameters, the following options can be used: Options :mandatory - If set, returns an error if the broker can&#39;t route the message to a queue (default false); :immediate - If set, returns an error if the broker can&#39;t deliver te message to a consumer immediately (default false); :content_type - MIME Content type; :content_encoding - MIME Content encoding; :headers - Message headers. Can be used with headers Exchanges; :persistent - If set, uses persistent delivery mode. Messages marked as persistent that are delivered to durable queues will be logged to disk; :correlation_id - application correlation identifier; :priority - message priority, ranging from 0 to 9; :reply_to - name of the reply queue; :expiration - how long the message is valid (in milliseconds); :message_id - message identifier; :timestamp - timestamp associated with this message (epoch time); :type - message type as a string; :user_id - creating user ID. RabbitMQ will validate this against the active connection user; :app_id - publishing application ID. Examples iex&gt; AMQP.Basic.publish chan, &quot;my_exchange&quot;, &quot;my_routing_key&quot;, &quot;Hello World!&quot;, persistent: true :ok"},{"ref":"AMQP.Basic.html#qos/2","title":"AMQP.Basic.qos/2","module":"AMQP.Basic","type":"function","doc":"Sets the message prefetch count or prefetech size (in bytes). If global is set to true this applies to the entire Connection, otherwise it applies only to the specified Channel."},{"ref":"AMQP.Basic.html#recover/2","title":"AMQP.Basic.recover/2","module":"AMQP.Basic","type":"function","doc":"Asks the server to redeliver all unacknowledged messages on a specified channel. If requeue is set to true the server will attempt to requeue the message, potentially delivering it to another subscriber. Otherwise it will be redelivered to the original recipient."},{"ref":"AMQP.Basic.html#reject/3","title":"AMQP.Basic.reject/3","module":"AMQP.Basic","type":"function","doc":"Rejects (and, optionally, requeues) a message."},{"ref":"AMQP.Basic.html#return/2","title":"AMQP.Basic.return/2","module":"AMQP.Basic","type":"function","doc":"Registers a handler to deal with returned messages. The registered process will receive {:basic_return, payload, meta} data structures."},{"ref":"AMQP.Basic.html#t:consumer_tag/0","title":"AMQP.Basic.consumer_tag/0","module":"AMQP.Basic","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:delivery_tag/0","title":"AMQP.Basic.delivery_tag/0","module":"AMQP.Basic","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:error/0","title":"AMQP.Basic.error/0","module":"AMQP.Basic","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:exchange/0","title":"AMQP.Basic.exchange/0","module":"AMQP.Basic","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:payload/0","title":"AMQP.Basic.payload/0","module":"AMQP.Basic","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:queue/0","title":"AMQP.Basic.queue/0","module":"AMQP.Basic","type":"type","doc":""},{"ref":"AMQP.Basic.html#t:routing_key/0","title":"AMQP.Basic.routing_key/0","module":"AMQP.Basic","type":"type","doc":""},{"ref":"AMQP.BasicError.html","title":"AMQP.BasicError","module":"AMQP.BasicError","type":"exception","doc":"Raised when the connection is closed or blocked."},{"ref":"AMQP.Channel.html","title":"AMQP.Channel","module":"AMQP.Channel","type":"module","doc":"Functions to operate on Channels."},{"ref":"AMQP.Channel.html#close/1","title":"AMQP.Channel.close/1","module":"AMQP.Channel","type":"function","doc":"Closes an open Channel."},{"ref":"AMQP.Channel.html#open/1","title":"AMQP.Channel.open/1","module":"AMQP.Channel","type":"function","doc":"Opens a new Channel in a previously opened Connection."},{"ref":"AMQP.Channel.html#t:t/0","title":"AMQP.Channel.t/0","module":"AMQP.Channel","type":"type","doc":""},{"ref":"AMQP.Confirm.html","title":"AMQP.Confirm","module":"AMQP.Confirm","type":"module","doc":"Functions that work with publisher confirms (RabbitMQ extension to AMQP 0.9.1)."},{"ref":"AMQP.Confirm.html#next_publish_seqno/1","title":"AMQP.Confirm.next_publish_seqno/1","module":"AMQP.Confirm","type":"function","doc":"On channel with confirm activated, return the next message sequence number. To use in combination with register_handler/2"},{"ref":"AMQP.Confirm.html#register_handler/2","title":"AMQP.Confirm.register_handler/2","module":"AMQP.Confirm","type":"function","doc":"Register a handler for confirms on channel. The handler will receive either: {:basic_ack, seqno, multiple} {:basic_nack, seqno, multiple} The seqno (delivery_tag) is an integer, the sequence number of the message. multiple is a boolean, when true means multiple messages confirm, upto seqno. see https://www.rabbitmq.com/confirms.html"},{"ref":"AMQP.Confirm.html#select/1","title":"AMQP.Confirm.select/1","module":"AMQP.Confirm","type":"function","doc":"Activates publishing confirmations on the channel."},{"ref":"AMQP.Confirm.html#unregister_handler/1","title":"AMQP.Confirm.unregister_handler/1","module":"AMQP.Confirm","type":"function","doc":"Remove the return handler. It does nothing if there is no such handler."},{"ref":"AMQP.Confirm.html#wait_for_confirms/1","title":"AMQP.Confirm.wait_for_confirms/1","module":"AMQP.Confirm","type":"function","doc":"Wait until all messages published since the last call have been either ack&#39;d or nack&#39;d by the broker."},{"ref":"AMQP.Confirm.html#wait_for_confirms/2","title":"AMQP.Confirm.wait_for_confirms/2","module":"AMQP.Confirm","type":"function","doc":"Wait until all messages published since the last call have been either ack&#39;d or nack&#39;d by the broker, or until timeout elapses."},{"ref":"AMQP.Confirm.html#wait_for_confirms_or_die/1","title":"AMQP.Confirm.wait_for_confirms_or_die/1","module":"AMQP.Confirm","type":"function","doc":"Wait until all messages published since the last call have been either ack&#39;d or nack&#39;d by the broker, or until timeout elapses. If any of the messages were nack&#39;d, the calling process dies."},{"ref":"AMQP.Confirm.html#wait_for_confirms_or_die/2","title":"AMQP.Confirm.wait_for_confirms_or_die/2","module":"AMQP.Confirm","type":"function","doc":""},{"ref":"AMQP.Connection.html","title":"AMQP.Connection","module":"AMQP.Connection","type":"module","doc":"Functions to operate on Connections."},{"ref":"AMQP.Connection.html#close/1","title":"AMQP.Connection.close/1","module":"AMQP.Connection","type":"function","doc":"Closes an open Connection."},{"ref":"AMQP.Connection.html#open/2","title":"AMQP.Connection.open/2","module":"AMQP.Connection","type":"function","doc":"Opens an new Connection to an AMQP broker. The connections created by this module are supervised under amqp_client&#39;s supervision tree. Please note that connections do not get restarted automatically by the supervision tree in case of a failure. If you need robust connections and channels, use monitors on the returned connection PID. The connection parameters can be passed as a keyword list or as a AMQP URI. When using a keyword list, the following options can be used: Options :username - The name of a user registered with the broker (defaults to &quot;guest&quot;); :password - The password of user (defaults to &quot;guest&quot;); :virtual_host - The name of a virtual host in the broker (defaults to &quot;/&quot;); :host - The hostname of the broker (defaults to &quot;localhost&quot;); :port - The port the broker is listening on (defaults to 5672); :channel_max - The channel_max handshake parameter (defaults to 0); :frame_max - The frame_max handshake parameter (defaults to 0); :heartbeat - The hearbeat interval in seconds (defaults to 10); :connection_timeout - The connection timeout in milliseconds (defaults to 50000); :ssl_options - Enable SSL by setting the location to cert files (defaults to :none); :client_properties - A list of extra client properties to be sent to the server, defaults to []; :socket_options - Extra socket options. These are appended to the default options. See http://www.erlang.org/doc/man/inet.html#setopts-2 and http://www.erlang.org/doc/man/gen_tcp.html#connect-4 for descriptions of the available options. Enabling SSL To enable SSL, supply the following in the ssl_options field: cacertfile - Specifies the certificates of the root Certificate Authorities that we wish to implicitly trust; certfile - The client&#39;s own certificate in PEM format; keyfile - The client&#39;s private key in PEM format; Example AMQP.Connection.open port: 5671, ssl_options: [cacertfile: &#39;/path/to/testca/cacert.pem&#39;, certfile: &#39;/path/to/client/cert.pem&#39;, keyfile: &#39;/path/to/client/key.pem&#39;, # only necessary with intermediate CAs # depth: 2, verify: :verify_peer, fail_if_no_peer_cert: true] Connection name RabbitMQ supports user-specified connection names since version 3.6.2. Connection names are human-readable strings that will be displayed in the management UI. Connection names do not have to be unique and cannot be used as connection identifiers. Examples iex&gt; AMQP.Connection.open host: &quot;localhost&quot;, port: 5672, virtual_host: &quot;/&quot;, username: &quot;guest&quot;, password: &quot;guest&quot; {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open &quot;amqp://guest:guest@localhost&quot; {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open &quot;amqp://guest:guest@localhost&quot;, &quot;a-connection-with-a-name&quot; {:ok, %AMQP.Connection{}}"},{"ref":"AMQP.Connection.html#t:t/0","title":"AMQP.Connection.t/0","module":"AMQP.Connection","type":"type","doc":""},{"ref":"AMQP.Exchange.html","title":"AMQP.Exchange","module":"AMQP.Exchange","type":"module","doc":"Functions to operate on Exchanges."},{"ref":"AMQP.Exchange.html#bind/4","title":"AMQP.Exchange.bind/4","module":"AMQP.Exchange","type":"function","doc":"Binds an Exchange to another Exchange or a Queue using the exchange.bind AMQP method (a RabbitMQ-specific extension)"},{"ref":"AMQP.Exchange.html#declare/4","title":"AMQP.Exchange.declare/4","module":"AMQP.Exchange","type":"function","doc":"Declares an Exchange. The default Exchange type is direct. AMQP 0-9-1 brokers provide four pre-declared exchanges: Direct exchange: (empty string) or amq.direct Fanout exchange: amq.fanout Topic exchange: amq.topic Headers exchange: amq.match (and amq.headers in RabbitMQ) Besides the exchange name and type, the following options can be used: Options :durable: If set, keeps the Exchange between restarts of the broker; :auto_delete: If set, deletes the Exchange once all queues unbind from it; :passive: If set, returns an error if the Exchange does not already exist; :internal: If set, the exchange may not be used directly by publishers, but only when bound to other exchanges. Internal exchanges are used to construct wiring that is not visible to applications."},{"ref":"AMQP.Exchange.html#delete/3","title":"AMQP.Exchange.delete/3","module":"AMQP.Exchange","type":"function","doc":"Deletes an Exchange by name. When an Exchange is deleted all bindings to it are also deleted"},{"ref":"AMQP.Exchange.html#direct/3","title":"AMQP.Exchange.direct/3","module":"AMQP.Exchange","type":"function","doc":"Convenience function to declare an Exchange of type direct."},{"ref":"AMQP.Exchange.html#fanout/3","title":"AMQP.Exchange.fanout/3","module":"AMQP.Exchange","type":"function","doc":"Convenience function to declare an Exchange of type fanout."},{"ref":"AMQP.Exchange.html#topic/3","title":"AMQP.Exchange.topic/3","module":"AMQP.Exchange","type":"function","doc":"Convenience function to declare an Exchange of type topic."},{"ref":"AMQP.Exchange.html#unbind/4","title":"AMQP.Exchange.unbind/4","module":"AMQP.Exchange","type":"function","doc":"Unbinds an Exchange from another Exchange or a Queue using the exchange.unbind AMQP method (a RabbitMQ-specific extension)"},{"ref":"AMQP.Queue.html","title":"AMQP.Queue","module":"AMQP.Queue","type":"module","doc":"Functions to operate on Queues."},{"ref":"AMQP.Queue.html#bind/4","title":"AMQP.Queue.bind/4","module":"AMQP.Queue","type":"function","doc":"Binds a Queue to an Exchange"},{"ref":"AMQP.Queue.html#consumer_count/2","title":"AMQP.Queue.consumer_count/2","module":"AMQP.Queue","type":"function","doc":"Returns a number of active consumers on the queue."},{"ref":"AMQP.Queue.html#declare/3","title":"AMQP.Queue.declare/3","module":"AMQP.Queue","type":"function","doc":"Declares a queue. The optional queue parameter is used to set the name. If set to an empty string (default), the server will assign a name. Besides the queue name, the following options can be used: Options :durable - If set, keeps the Queue between restarts of the broker :auto_delete - If set, deletes the Queue once all subscribers disconnect :exclusive - If set, only one subscriber can consume from the Queue :passive - If set, raises an error unless the queue already exists"},{"ref":"AMQP.Queue.html#delete/3","title":"AMQP.Queue.delete/3","module":"AMQP.Queue","type":"function","doc":"Deletes a Queue by name"},{"ref":"AMQP.Queue.html#empty?/2","title":"AMQP.Queue.empty?/2","module":"AMQP.Queue","type":"function","doc":"Returns true if queue is empty (has no messages ready), false otherwise."},{"ref":"AMQP.Queue.html#message_count/2","title":"AMQP.Queue.message_count/2","module":"AMQP.Queue","type":"function","doc":"Returns the number of messages that are ready for delivery (e.g. not pending acknowledgements) in the queue."},{"ref":"AMQP.Queue.html#purge/2","title":"AMQP.Queue.purge/2","module":"AMQP.Queue","type":"function","doc":"Discards all messages in the Queue"},{"ref":"AMQP.Queue.html#status/2","title":"AMQP.Queue.status/2","module":"AMQP.Queue","type":"function","doc":"Returns the message count and consumer count for the given queue. Uses Queue.declare with the passive option set."},{"ref":"AMQP.Queue.html#subscribe/3","title":"AMQP.Queue.subscribe/3","module":"AMQP.Queue","type":"function","doc":"Convenience to consume messages from a Queue. The handler function must have arity 2 and will receive as arguments a binary with the message payload and a Map with the message properties. The consumed message will be acknowledged after executing the handler function. If an exception is raised by the handler function, the message is rejected. This convenience function will spawn a process and register it using AMQP.Basic.consume."},{"ref":"AMQP.Queue.html#unbind/4","title":"AMQP.Queue.unbind/4","module":"AMQP.Queue","type":"function","doc":"Unbinds a Queue from an Exchange"},{"ref":"AMQP.Queue.html#unsubscribe/2","title":"AMQP.Queue.unsubscribe/2","module":"AMQP.Queue","type":"function","doc":"Convenience to end a Queue consumer."},{"ref":"readme.html","title":"AMQP","module":"readme","type":"extras","doc":"AMQP Simple Elixir wrapper for the Erlang RabbitMQ client. The API is based on Langohr, a Clojure client for RabbitMQ."},{"ref":"readme.html#migration-from-0-x-to-1-0","title":"AMQP - Migration from 0.X to 1.0","module":"readme","type":"extras","doc":"If you use amqp 0.X and plan to migrate to 1.0 please read our migration guide."},{"ref":"readme.html#usage","title":"AMQP - Usage","module":"readme","type":"extras","doc":"Add AMQP as a dependency in your mix.exs file. def deps do [{:amqp, &quot;~&gt; 1.1&quot;}] end You should also update your application list to include :amqp: def application do [applications: [:amqp]] end After you are done, run mix deps.get in your shell to fetch and compile AMQP. Start an interactive Elixir shell with iex -S mix. iex&gt; {:ok, conn} = AMQP.Connection.open {:ok, %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}} iex&gt; {:ok, chan} = AMQP.Channel.open(conn) {:ok, %AMQP.Channel{conn: %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}, pid: #PID&lt;0.177.0&gt;} iex&gt; AMQP.Queue.declare chan, &quot;test_queue&quot; {:ok, %{consumer_count: 0, message_count: 0, queue: &quot;test_queue&quot;}} iex&gt; AMQP.Exchange.declare chan, &quot;test_exchange&quot; :ok iex&gt; AMQP.Queue.bind chan, &quot;test_queue&quot;, &quot;test_exchange&quot; :ok iex&gt; AMQP.Basic.publish chan, &quot;test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot; :ok iex&gt; {:ok, payload, meta} = AMQP.Basic.get chan, &quot;test_queue&quot; iex&gt; payload &quot;Hello, World!&quot; iex&gt; AMQP.Queue.subscribe chan, &quot;test_queue&quot;, fn(payload, _meta) -&gt; IO.puts(&quot;Received: \#{payload}&quot;) end {:ok, &quot;amq.ctag-5L8U-n0HU5doEsNTQpaXWg&quot;} iex&gt; AMQP.Basic.publish chan, &quot;test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot; :ok Received: Hello, World! Setup a consumer GenServer defmodule Consumer do use GenServer use AMQP def start_link do GenServer.start_link(__MODULE__, [], []) end @exchange &quot;gen_server_test_exchange&quot; @queue &quot;gen_server_test_queue&quot; @queue_error &quot;\#{@queue}_error&quot; def init(_opts) do {:ok, conn} = Connection.open(&quot;amqp://guest:guest@localhost&quot;) {:ok, chan} = Channel.open(conn) setup_queue(chan) # Limit unacknowledged messages to 10 :ok = Basic.qos(chan, prefetch_count: 10) # Register the GenServer process as a consumer {:ok, _consumer_tag} = Basic.consume(chan, @queue) {:ok, chan} end # Confirmation sent by the broker after registering this process as a consumer def handle_info({:basic_consume_ok, %{consumer_tag: consumer_tag}}, chan) do {:noreply, chan} end # Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion) def handle_info({:basic_cancel, %{consumer_tag: consumer_tag}}, chan) do {:stop, :normal, chan} end # Confirmation sent by the broker to the consumer process after a Basic.cancel def handle_info({:basic_cancel_ok, %{consumer_tag: consumer_tag}}, chan) do {:noreply, chan} end def handle_info({:basic_deliver, payload, %{delivery_tag: tag, redelivered: redelivered}}, chan) do # You might want to run payload consumption in separate Tasks in production consume(chan, tag, redelivered, payload) {:noreply, chan} end defp setup_queue(chan) do {:ok, _} = Queue.declare(chan, @queue_error, durable: true) # Messages that cannot be delivered to any consumer in the main queue will be routed to the error queue {:ok, _} = Queue.declare(chan, @queue, durable: true, arguments: [ {&quot;x-dead-letter-exchange&quot;, :longstr, &quot;&quot;}, {&quot;x-dead-letter-routing-key&quot;, :longstr, @queue_error} ] ) :ok = Exchange.fanout(chan, @exchange, durable: true) :ok = Queue.bind(chan, @queue, @exchange) end defp consume(channel, tag, redelivered, payload) do number = String.to_integer(payload) if number &lt;= 10 do :ok = Basic.ack channel, tag IO.puts &quot;Consumed a \#{number}.&quot; else :ok = Basic.reject channel, tag, requeue: false IO.puts &quot;\#{number} is too big and was rejected.&quot; end rescue # Requeue unless it&#39;s a redelivered message. # This means we will retry consuming a message once in case of exception # before we give up and have it moved to the error queue # # You might also want to catch :exit signal in production code. # Make sure you call ack, nack or reject otherwise comsumer will stop # receiving messages. exception -&gt; :ok = Basic.reject channel, tag, requeue: not redelivered IO.puts &quot;Error converting \#{payload} to integer&quot; end end iex&gt; Consumer.start_link {:ok, #PID&lt;0.261.0&gt;} iex&gt; {:ok, conn} = AMQP.Connection.open {:ok, %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}} iex&gt; {:ok, chan} = AMQP.Channel.open(conn) {:ok, %AMQP.Channel{conn: %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}, pid: #PID&lt;0.177.0&gt;} iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;5&quot; :ok Consumed a 5. iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;42&quot; :ok 42 is too big and was rejected. iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot; :ok Error converting Hello, World! to integer Error converting Hello, World! to integer"},{"ref":"readme.html#stable-rabbitmq-connection","title":"AMQP - Stable RabbitMQ Connection","module":"readme","type":"extras","doc":"While the above example works, it does nothing to handle RabbitMQ connection outages. In case of an outage your Genserver will remain stale and won&#39;t receive any messages from the broker as the connection is never restarted. Luckily, implementing a reconnection logic is quite straight forward. Since the connection record holds the pid of the connection itself, we can monitor it and get a notification when it goes down. Example implementation (only changes from the last example): # 1. Extract your connect logic into a private method rabbitmq_connect def init(_opts) do rabbitmq_connect end defp rabbitmq_connect do case Connection.open(&quot;amqp://guest:guest@localhost&quot;) do {:ok, conn} -&gt; # Get notifications when the connection goes down Process.monitor(conn.pid) # Everything else remains the same {:ok, chan} = Channel.open(conn) setup_queue(chan) Basic.qos(chan, prefetch_count: 10) {:ok, _consumer_tag} = Basic.consume(chan, @queue) {:ok, chan} {:error, _} -&gt; # Reconnection loop :timer.sleep(10000) rabbitmq_connect end end # 2. Implement a callback to handle DOWN notifications from the system # This callback should try to reconnect to the server def handle_info({:DOWN, _, :process, _pid, _reason}, _) do {:ok, chan} = rabbitmq_connect {:noreply, chan} end Now, when the connection drops, or if the server is down when your application starts, it will try to reconnect indefinitely until it succeeds."},{"ref":"readme.html#types-of-arguments-and-headers","title":"AMQP - Types of arguments and headers","module":"readme","type":"extras","doc":"The parameter arguments in Queue.declare, Exchange.declare, Basic.consume and the parameter headers in Basic.publish are a list of tuples in the form {name, type, value}, where name is a binary containing the argument/header name, type is an atom describing the AMQP field type and value a term compatible with the AMQP field type. The valid AMQP field types are: :longstr | :signedint | :decimal | :timestamp | :table | :byte | :double | :float | :long | :short | :bool | :binary | :void | :array Valid argument names in Queue.declare include: &quot;x-expires&quot; &quot;x-message-ttl&quot; &quot;x-dead-letter-routing-key&quot; &quot;x-dead-letter-exchange&quot; &quot;x-max-length&quot; &quot;x-max-length-bytes&quot; Valid argument names in Basic.consume include: &quot;x-priority&quot; &quot;x-cancel-on-ha-failover&quot; Valid argument names in Exchange.declare include: &quot;alternate-exchange&quot;"},{"ref":"readme.html#troubleshooting-faq","title":"AMQP - Troubleshooting / FAQ","module":"readme","type":"extras","doc":"Consumer stops receiving messages Most popular cause is your code not sending acknowledgement(ack, nack or reject) after receiving a message. You want to investigate if... an exception was raised and how it would be handled :exit signal was thrown and how it would be handled a message processing took long time. If you use GenServer in consumer, try storing number of messages the server is currently processing to the GenServer state. If the number equals prefetch\\_count, those messages were left without acknowledgements and that&#39;s why consumer have stopped receiving more messages. Old version of Elixir or OTP OTP 17 and 18 are supported only on version 0.1.x. Please understand that we won&#39;t make further changes to 0.1 except for major security issues. Heartbeats In case the connection is dropped automatically, consider enabling heartbeats. You can set heartbeat option when you open a connection. For more details, read this article Log related to amqp supervisors are too verbose Try the following configuration. config :logger, handle_otp_reports: false Or try filtering out the messages at your application start: :logger.add_primary_filter( :ignore_rabbitmq_progress_reports, {&amp;:logger_filters.domain/2, {:stop, :equal, [:progress]}} ) See this comment for the details. Lager conflicts with Elixir logger Lager is used by rabbit_common and it is not Elixir&#39;s best friend yet. You need a workaround. In mix.exs, you have to load :lager before :logger. extra_applications: [:lager, :logger, :amqp] Here is a sample configuration to silent rabbit_common logging. config :lager, error_logger_redirect: false, handlers: [level: :critical] Check out Lager and RabbitMQ documentation for more information. Compile error on ranch_proxy_protocol with OTP 21 Update amqp to 1.1.0 or a greater version. Does the library support AMQP 1.0? Currently the library doesn&#39;t support AMQP 1.0 and there is no plan to do so at the moment. Our main aim here (at least for now) is to provide a thin wrapper around amqp_client for Elixir programmers."}]